{$A+,B-,E-,F-,G+,I-,N-,O-,V-,X+ }

{ -- vu ??? --^^ !!! }

{$IFDEF DEBUG }
  {$D+,L+,R+,S+ }
{$ELSE }
  {$D-,L-,R-,S- }
{$ENDIF }

{$M 30000, 163840, 655360 }

Program NamSim;

Uses Dos,Crt,Colors,Video60,XSer,XSerDigi,XDlib,VdtTools,VdtDisp,EmulM2;


Const  __c18__ : LongInt = 0;
       sv_c18  : LongInt = 0;
       ex_c18  : LongInt = 0;

Function GetC18 : Longint;
Begin
 Asm
  mov ax, 0040h
  mov es, ax
  cli
  mov ax, [es:06Ch]
  mov dx, [es:06Eh]
  sti
  mov [WORD PTR __c18__], ax
  mov [WORD PTR __c18__+2], dx
 End;

 If (sv_c18=0) Then
  Begin
   sv_c18 := 1;
  End
 Else
  If (ex_c18>__c18__) Then Inc(sv_c18,ex_c18);

 ex_c18 := __c18__;

 GetC18 := sv_c18+__c18__;
End;


Function Byte2Hex( x : Byte ) : String; Assembler;
Asm
    cld

    les  di, [@Result]
    mov  [BYTE PTR es:di], 2    { car "00" a une longueur fixe de 2 }
    inc  di                      { se place }

    mov  al, [x]
    mov  cl, 4
    shr  al, cl            { decal les 4 bits suprieur }
    add  al, 90h
    daa
    adc  al, 40h
    daa
    stosb
    mov  al, [x]
    and  al, 15            { les 4 bits infrieurs }
    add  al, 90h
    daa
    adc  al, 40h
    daa
    stosb
End;


Function Word2Hex( x : Word ) : String; Assembler;
Asm
    cld

    les  di, [@Result]
    mov  [BYTE PTR es:di], 4   { car "0000" a une longueur fixe de 4 }
    inc  di                { se place }

    mov  cl, 4
    mov  bx, [x]
    mov  al, bh
    shr  al, cl            { decal les 4 bits suprieur }
    add  al, 90h
    daa
    adc  al, 40h
    daa
    stosb
    mov  al, bh
    and  al, 15            { les 4 bits infrieurs }
    add  al, 90h
    daa
    adc  al, 40h
    daa
    stosb
    mov  al, bl
    shr  al, cl            { decal les 4 bits suprieur }
    add  al, 90h
    daa
    adc  al, 40h
    daa
    stosb
    mov  al, bl
    and  al, 15            { les 4 bits infrieurs }
    add  al, 90h
    daa
    adc  al, 40h
    daa
    stosb
End;

Var HeapFail : Boolean;

Function FoncTas(lg : word) : Word; Far;
Begin { fin de tout ! }
 If lg>0 then
  Begin
   HeapFail := TRUE;
   FoncTas := 0;
  End;
End;

Const
      VMODE_UNDEF = 0;
      VMODE_MDA   = 1;
      VMODE_CGA   = 2;

      VideoMode : Byte = VMODE_UNDEF;
      Grey      : Boolean = TRUE;
      EgaLight  : Boolean = FALSE;
      Neige     : Boolean = FALSE;
      NeedHelp  : Boolean = FALSE;

      ScrHi     : Word = 25;

      HowQuit   : Word = 0;

      Fermic    : Boolean = TRUE;

      SIZEMAXFILE = 8192;      { taille maxi a extraire d'un fichier vdt }

      CAUSE_PAV    = $C6;

      SUBST_Old : String[80] = '';
      SUBST_New : String[80] = '';

Const MaxNbVoies = 26;

Const
      ComBufSize = 32;

      EchoBufSize = 128;

      TempoSleep  = 16*60*4;

      TempoDcnx   = TempoSleep+16*60*1;

      EmptyStr : String[1] = '';

      EnReso : Boolean = FALSE;

      R2F_nPAV : Byte = 0;       { rien pas defaut... }

      PavMinMax = 64;

Type CallStr = String[30];

     VoieRec = Record
       LastCnxC18 : LongInt;     { time out de tentative de connexion }
       CStr      : CallStr;      { chaine ayant engag la communication }
       SaveCStr  : CallStr;      { etat sauv avant chaque appel }
       ComOn     : Boolean;      { TRUE=>communication tablie }
       Dispo     : Boolean;      { TRUE=>la communication est disponible }
       LastIn    : Byte;         { dernire trame recue }
       LastOut   : Byte;         { dernire trame mise }
       Roto      : Byte;         { lment rotatif -\/ }
       Input     : String[128];  { si emul, ce qui est tap }

       E         : EmulRec;      { l'mulateur }
      End;

     PVoieRec = ^VoieRec;

     ComCfg = Record
       UART : Word;
       IRQ  : Byte;
       Par  : Byte;
       Spd  : LongInt;
       BufIn : Word;
       BufOut : Word;
      End;

     PComCfg = ^ComCfg;

     NamCfg = Record
       SaisieLibre : Boolean;
       CnxAuto     : Boolean;
       UseDRCS     : Boolean;
       HiSpd       : Boolean;
      End;

     NamDef = Record
       nNam     : Byte;
       Cfg      : ComCfg;
       NCfg     : NamCfg;
       Com      : ComNam;
       TabVoies : Array[0..MaxNbVoies-1] Of VoieRec;
       GlDispo  : Boolean;
       nVoie    : Byte;     { n voie courante }
       Passe    : String[8];          { mot de passe ventuel... }
      End;

     PNamDef = ^NamDef;


     TransCodage = ( TC_TRANSP,       { aucun transcodage }
                     TC_VDXT,         { SEP XY => XY 0D }
                     TC_ISO2022       { ? }
                   );

     VDTAig  = ( VA_NIL,
                 VA_1,
                 VA_2,
                 VA_3,
                 VA_SS2,           { 19h .. }
                 VA_ESC,           { 1Bh .. }
                 VA_ISO2022,       { 1Bh XXh .. }
                 VA_ISO6429,       { 1Bh XXh .. }
                 VA_SOH            { 01h ... 04h }
               );

     ResultAig = ( RA_CHAR,        { XXh  Caractere }
                   RA_SS2,         { 19h XXh  Caractere etendu }
                   RA_SS2Bis,      { 19h XXh YYh  ... }
                   RA_SS3,         { 1Dh XXh }
                   RA_CTRL,        { caractere de controle (<32) }
                   RA_SOH,         { 01h ... 04h }
                   RA_SEP,         { 13h XXh }
                   RA_REP,         { 12h XXh }
                   RA_US,          { 1Fh XXh YYh }
                   RA_ESC,         { 1Bh XXh }
                   RA_PRO,         { 1Bh XXh YYh ZZh @@h }
                   RA_ISO2022,     { 1Bh XXh .. }
                   RA_ISO6429,     { 1Bh XXh .. }
                   RA_FILT );      { 1Bh XXh YYh }




     EqSeqStr = String[31];


     ComBufRec = Record
       Buf        : Array[0..ComBufSize-1] Of Char;
       iWrite     : Byte;
       Nb         : Byte;
      End;

     SeqStr  = String[17];

     PaviSeqRec = Record
       Seq            : SeqStr;      { Petit buffer (avant le grand) }
       Aig            : VDTAig;      { etat d'analyse donne entr }
       Tp             : ResultAig;   { valide si Aig=NIL }
       Ti             : Longint;     { instant derniere entre }
       Avert          : Boolean;     { TRUE=>timeout proche }
       NoTimeOut   : Boolean;     { TRUE=>pas de TimeOut en local ou autre }
      End;

     PaviEchoRec = Record
       Echo           : Boolean;     { TRUE=>renvoi en ECHO }
       Flush          : Boolean;     { force l'emission ds que possible }
       Buf            : Array[0..EchoBufSize-1] Of Char;
       Lg             : Byte;
      End;

{     PaviBuf = Array[0..127] Of Char; }
     PaviBuf          = String[128];

     CmdSeqStr = String[31];          { Commande pour l'equipement }

     PaviRec = Record
       DataSize       : Word;        { Taille du champs de donnes max }
       TC             : Transcodage; { Transcodage des envoi }
       LZ             : Boolean;
       Break          : Boolean;
       Seq            : PaviSeqRec;
       Echo           : PaviEchoRec;
       sBuf           : PaviBuf;
{       LgBuf          : Byte; }
      End;

     PPaviRec = ^PaviRec;


     EqMinCfg = Record
       IReset      : EqSeqStr;    { Init/Reset quipement }
       WCall       : EqSeqStr;    { Donnes d'appel  attendre }
       WHangUp0    : EqSeqStr;    { squence de deco avant connexion }
       SConnect    : EqSeqStr;    { Donnes de connexion }
       WConnect    : EqSeqStr;    { Donnes de connexion  attendre }
       TConnect    : Word;        { Time Out en attente }
       SOnLine     : EqSeqStr;    { envoi si communication etablie }
       WHangUp     : EqSeqStr;    { squence de deconnexion }
       SHangUp     : EqSeqStr;    { force la dconnexion }
      End;


     PMPaq = ^MPaq;

     MPaq = Record
       Tp          : Byte;              { Type de donnes }
       Don         : String;            { les donnes }
       Next        : PMPaq;             { la suite... }
      End;

     MinPaq = Record
       First       : PMPaq;
       Last        : PMPaq;
      End;

     MinPage = Record
       Page        : String[12];
       Guide       : String[8];
       Lig         : Byte;
       Col         : Byte;
       Lg          : Byte;
      End;

     MinSys = Record
       PaqIn       : MinPaq;      { paquet recu }
       PaqOut      : MinPaq;      { paquet a emettre }
       cvon        : Boolean;     { TRUE=>connecte FALSE=>ignor ce qui suit!!! }
       iPos        : Integer;     { position de traitement EN CONNEXION! }
       Page        : MinPage;     { les pages associs... }
       TCnx        : Word;        { temps d'attente de cnx  un service }
       TimeOut     : Longint;
       nGuide      : Word;
       Link        : Boolean;
       CnxTimeOut  : Longint;
       Nam         : PNamDef;
       nVoie       : Byte;
       Voie        : PVoieRec;
       LibDiag     : Byte;
       LibCause    : Byte;
       CurrentNam  : PNamDef;
       IsMaster    : Boolean;   { indique qu'il est maitre du "lock" nam... }
      End;

     PMinSys = ^MinSys;

     MinPos = (
       MPOS_RESET,              { initialisation / fin com. }
       MPOS_WRING,              { attendre un signal d'appel }
       MPOS_WCNX,               { attendre confirmation d'appel }
       MPOS_CNX                 { en cours de connexion }
      );




     MinDef = Record
       Cfg         : ComCfg;
       Com         : ComMin;
       Eq          : EqMinCfg;
       Buf         : ComBufRec;
       Pavi        : PaviRec;
       MainNam     : Byte;
       MPos        : MinPos;            { position de traitement io }
       TimeOut     : LongInt;           { timer au niveau io... }
       Sys         : MinSys;
      End;

     PMinDef = ^MinDef;


     PavCfg = Record
       MinMax      : Word;
      End;

     PavMinDef = Record
       OnLine      : Boolean;           { appel toujours actif }
       oPos        : Integer;
       nc          : Integer;           { nc lors de l'appel (-1=>aucun) }
       Id          : Word;              { Id issue de la trame d'appel }
       FastConnect : Boolean;           { la connexion fut immediate? }
       Sys         : MinSys;
      End;

     PPavMinDef = ^PavMinDef;

     PavDef = Record
       nPav        : Byte;
       Cfg         : ComCfg;
       Com         : ComNam;
       PCfg        : PavCfg;
(*       Page        : MinPage; *)
       TMin        : Array[1..PavMinMax] Of PPavMinDef;
      End;

     PPavDef = ^PavDef;

Const NamComDefault : ComCfg = (
   UART      : 0;
   IRQ       : 0;
   Par       : DATA8BITS+NOPARITY+STOP1BIT;
   Spd       : 9600;
   BufIn     : 16384;
   BufOut    : 16384
 );
     NamCfgDefault : NamCfg = (
   SaisieLibre : FALSE;
   CnxAuto   : FALSE;
   UseDRCS   : TRUE;
   HiSpd     : FALSE
 );

      NamMax = 10;

      MinComDefault : ComCfg = (
   UART      : 0;
   IRQ       : 0;
   Par       : DATA7BITS+EVENPARITY+STOP1BIT;
   Spd       : 4800;
   BufIn     : 128;     { 512; }
   BufOut    : 512      { 16384 }
 );

      Default_TCNX = 5;

      DefaultLocalMatCfg : EqMinCfg = (
       IReset      : #$1B#$39#$7F;     { Reset }
       WCall       : #$13'I'; { [Shift]+[Cnx] }
       WHangUp0    : '';
       SConnect    : #27#57#$70;       { demande status }
       WConnect    : #27#58#$71#$01;   { reponse status }
       TConnect    : 5*16;             { rien }
       SOnLine     : #$1B#$39#$7F+#$1B#$3B#$60#$5A#$51;  { Reset+pas d'echo }
       WHangUp     : '';               { rien }
       SHangUp     : ''                { rien }
       );

      DefaultPage : MinPage = (
       Page        : 'NAMSIM.VDT';
       Guide       : 'NAMGUIDE';
       Lig         : 18;
       Col         : 12;
       Lg          : 29
       );

      DefaultRTCMatCfg : EqMinCfg = (
       IReset      : #$1B#$39#$7F;     { Reset }
       WCall       : #$13#$6C;         { signal d'appel }
       WHangUp0    : '';               { rien }
       SConnect    : #$1B#$39#$53#$1B#$39#$6F#$1B#$39#$68;  { ligne+opp+cnx }
       WConnect    : #$13#$53;         { prise de ligne ok }
       TConnect    : 15*18;            { 20 secondes }
       SOnLine     : '';
       WHangUp     : #$13#$53;               { rien }
       SHangUp     : #$1B#$39#$67#$1B#$39#$57 { deco + lib ligne }
       );

      MinMax = 32;

      PavComDefault : ComCfg = (
   UART      : 0;
   IRQ       : 0;
   Par       : DATA7BITS+EVENPARITY+STOP1BIT;
   Spd       : 4800;
   BufIn     : 512;
   BufOut    : 16384
 );


      PavCfgDefault : PavCfg = (
        MinMax     : 32
       );

      PavMax = 4;

Var TNam : Array[1..NamMax] Of PNamDef;

    TMin : Array[1..MinMax] Of PMinDef;

    TPav : Array[1..PavMax] Of PPavDef;

Const
      POSLZ          = #0#31'@A'#24;

Const
      DATA_DATA      = 0;       { donnes pures... elles peuvent etre concatn }
      DATA_EXPRESS   = 1;       { donnes express... un paquet seul ... }
      DATA_RESET     = 2;       { ordre de reset du terminal (selon le type connect) }


Procedure PaqPush( Var mp : MinPaq; Tp : Byte; Var d : String );
Var id : PMPaq;
    ir : Word;
    len : Word;
Begin
 len := Length(d);
 ir := 0;
 id := mp.Last;

 If (id<>NIL) And (Tp=DATA_DATA) And (id^.Tp=DATA_DATA) Then
  Begin
   While (ir<len) And (Length(id^.Don)<(SizeOf(id^.Don)-1)) Do
    Begin
     Inc(ir);
     id^.Don[Length(id^.Don)+1] := d[ir];
     Inc(id^.Don[0]);
    End;

  End;

 If (ir>=len) And ((Tp=DATA_DATA) Or (Tp=DATA_EXPRESS)) Then Exit;    { plus rien a faire pour les donnes!! }

 { la methode qui suit permet d'envoyer des paquets vides!!! }
 { les controles ci-dessus fait une exception pour les donnees... }

 Repeat

   New(id);

   id^.Tp := Tp;
   id^.Don[0] := Char(0);
   id^.Next := NIL;

   While (ir<len) And (Length(id^.Don)<(SizeOf(id^.Don)-1)) Do
    Begin
     Inc(ir);
     id^.Don[Length(id^.Don)+1] := d[ir];
     Inc(id^.Don[0]);
    End;

   If (mp.Last=NIL) Then mp.First := id
   Else mp.Last^.Next := id;

   mp.Last := id;

 Until (ir>=len);
End;


Function PaqPop( Var mp : MinPaq; Var Tp : Byte; Var d : String ) : Boolean;
Var id : PMPaq;
Begin
 If (mp.First<>NIL) Then
  Begin
   id := mp.First;

   Tp := id^.Tp;
   d := id^.Don;

   mp.First := id^.Next;
   If (mp.First=NIL) Then mp.Last := NIL;

   Dispose(id);

   PaqPop := TRUE;
  End
 Else PaqPop := FALSE;
End;


Function PaqFlush( Var mp : MinPaq ) : Boolean;
Var d : String;
    Tp : Byte;
Begin
 While PaqPop(mp,Tp,d) Do;
End;


Procedure PaqSendData( Var mp : MinPaq; Var p; Lg : Word );
Var d : String;
    ir : Word;
    len : Word;
    c : Array[0..30000] Of Char Absolute p;
Begin
 len := 0;
 ir := 0;
 While(lg>0) Do
  Begin
   If (lg>(SizeOf(d)-1)) Then len := SizeOf(d)-1
   Else len := lg;

   move(c[ir],d[1],len);
   d[0] := Char(len);

   Dec(lg,len);
   Inc(ir,len);

   PaqPush(mp,DATA_DATA,d);
  End;
End;


Procedure PaqSend( Var mp : MinPaq; Tp : Byte; Var p; Lg : Word );
Var d : String;
    len : Word;
Begin
 len := 0;

 If (lg>(SizeOf(d)-1)) Then len := SizeOf(d)-1
 Else len := lg;

 move(p,d[1],len);
 d[0] := Char(len);

 PaqPush(mp,Tp,d);
End;



Procedure PaqSendExpress( Var mp : MinPaq; Var p; Lg : Word );
Begin
 PaqSend(mp,DATA_EXPRESS,p,lg);
End;


Procedure PaqSendReset( Var mp : MinPaq );
Var s : String[1];
Begin
 s := '';
 PaqSend(mp,DATA_RESET,s[1],length(s));
End;


Function PaqEmpty( Var mp : MinPaq ) : Boolean;
Begin
 PaqEmpty := (mp.First=NIL);
End;


Procedure Beep;
Begin
 Sound(850);
 Delay(10);
 NoSound;
End;

Procedure BeepLong;
Begin
 Sound(850);
 Delay(500);
 NoSOund;
End;


Function _Val2Str( x : Longint; Surf : Byte ) : String;
Var s : String[12];
Begin
 Str(x:Surf,s);
 _Val2Str := s;
End;


Function Val2Str( x : Longint; Surf : Byte ) : String;
Var s : String[12];
    i : Byte;
Begin
 Str(x:Surf,s);
 i := 1;
 While (s[i]=' ') Do
  Begin
   s[i] := '0';
   Inc(i);
  End;
 Val2Str := s;
End;


Const NbVoies : Word = 16;

      LVoies  = 1;   { nligne o commence l'affichage des voies }

      LGlDispo   = 0;
      ColGlDispo = 3+8;
      CarGlDispo = 9;

      ColAct  = 2;   { colonne ou indiquer "ComOn" }
      ColInfo = 5;
      ColIn   = 36;
      ColRoto = 37;
      ColOut  = 38;

      CarComOn   = Byte('C'); { 42; } { 254; }
      CarComWait = 33; { 9; }

      CVBase  = 64;

      INTVIDEO = $10;


      T_ENVOI       = #$41;
      T_RETOUR      = #$42;
      T_REPETITION  = #$43;
      T_GUIDE       = #$44;
      T_ANNULATION  = #$45;
      T_SOMMAIRE    = #$46;
      T_CORRECTION  = #$47;
      T_SUITE       = #$48;


      TabRoto : Array[0..3] Of Char = ('-','\','|','/');

      ColTabCStr = 44;
      LTabCStr = 1;

      NbCStr = 20;

      NABMax = 100;

Type NABRec = Record
       NAB   : String[12];
       CStr  : CallStr;
      End;

Var
    TabCStr  : Array[0..NbCStr-1] Of CallStr;

    nCStr    : Byte;     { n de CStr courant }
    FCStr    : Byte;

    TabNab   : Array[0..NABMax-1] Of NABRec;

    NbNab    : Byte;

    ECurX    : Byte;
    ECurY    : Byte;

    EndMain : Boolean;   { fin du programme }
    Refresh : Boolean;   { force le raffichage complet }
    RAff    : Boolean;   { actualise la voie courante }

    CNam     : PNamDef;
    nCNam    : Word;
    NamScr  : PNamDef;
    MemFree : Word;

    CCfg    : PComCfg;

    CMin    : PMinDef;
    nCMin   : Word;

    CPav    : PPavDef;
    nCPav   : Word;

{$I CONFIG.PAS }

{$I NAMCTRL.PAS }

{ -------------------------- }

Procedure CurOFF; Assembler;
Asm
End;
(*
Asm
    MOV  AH, 03h
    MOV  BH, 0
    INT  INTVIDEO         { lire position curseur ET etat curseur }
    MOV  AH, 01h
    AND  CH, 10011111b    { bit 5-6  00 }
    OR   CH, 00100000b    { bit 5-6 = 01 => invisible }
    INT  INTVIDEO
End;
*)

Procedure CurON; Assembler;
Asm
End;
(*
Asm
    MOV  AH, 03h
    MOV  BH, 0
    INT  INTVIDEO         { lire position curseur ET etat curseur }
    MOV  AH, 01h
    AND  CH, 10011111b    { bit 5-6  00 }
    INT  INTVIDEO
End;
*)


Procedure CurSmall; Assembler;
Asm
End;
(*
Asm
    MOV  AH, 03h
    MOV  BH, 0
    INT  INTVIDEO         { lire position curseur ET etat curseur }
    AND  CH, 11100000b    { garder bit5  7 }
    AND  CL, 11100000b
    CMP  [VideoMode], VMODE_MDA
    JNE  @ICI
    OR   CH, 11           { ligne de debut }
    OR   CL, 12           { ligne fin }
    JMP  @SETCUR
@ICI:
    OR   CH, 6            { ligne de debut }
    OR   CL, 7            { ligne fin }
@SETCUR:
    MOV  AH, 01h
    INT  INTVIDEO
End;
*)

Procedure CurBig; Assembler;
Asm
End;
(*
Asm
    MOV  AH, 03h
    MOV  BH, 0
    INT  INTVIDEO         { lire position curseur ET etat curseur }
    AND  CH, 11100000b    { garder bit5  7 }
    AND  CL, 11100000b
    CMP  [VideoMode], VMODE_MDA
    JNE  @ICI
    OR   CH, 0            { ligne de debut }
    OR   CL, 13           { ligne fin }
    JMP  @SETCUR
@ICI:
    OR   CH, 0            { ligne de debut }
    OR   CL, 7            { ligne fin }
@SETCUR:
    MOV  AH, 01h
    INT  INTVIDEO
End;
*)


Procedure CurPos( column, row : Byte ); Assembler;
Asm
    MOV  AH, 02h
    MOV  DL, column
    MOV  DH, row
    XOR  BH, BH
    INT  INTVIDEO
End;


Procedure VideoInit;
Var Reg : Registers;
    vm  : Byte;
Begin
  { Init Video }
  vm := OpenVideoSys(VideoMode,Neige,Grey,EGALight);
  VideoMode := vm;
End;


Procedure VideoDone;
Begin
 CloseVideoSys;
End;

Procedure FlashOff;
Begin
 WrtDt(32,1,0,CRvs);
 WrtDt(32,9,0,CRvs);
End;

Procedure FlashOn;
Begin
 WrtDt(16,1,0,CRvs);
 WrtDt(17,9,0,CRvs);
End;


Procedure CheckRefresh( Var Nam : NamDef );
Begin
 If @Nam=NamScr Then Refresh := TRUE;
End;

Procedure RefreshEcran( Var Nam : NamDef );
Var i : Byte;
    c : Char;
    v : PVoieRec;
Begin
 If @Nam<>NamScr Then Exit;

 FillZc(0,0,40,ScrHi,32,CRien);

 WrtScr('   NAM'+_Val2Str(Nam.nNam,2)+'             '+Word2Hex(Nam.Cfg.UART)+
        ' '+Byte2Hex(Nam.Cfg.IRQ)+' '+_Val2Str(Nam.Cfg.Spd,6)+'I O ',0,0,CRvs);

 If Nam.Com.C_Trama<>TR_GET_STX Then WrtDt(9,0,0,CRvs);

 If Nam.GlDispo Then WrtDt(Byte(' '),ColGlDispo,LGlDispo,CRvs)
 Else WrtDt(CarGlDispo,ColGlDispo,LGlDispo,CRvs+128);

 For i := 0 To NbVoies-1 Do
  Begin
   WrtDt(Byte(''),0,i+LVoies,CRien);

   If i<10 Then c := Char(48+i) Else c := Char(55+i);
   WrtDt(Byte(c),1,i+LVoies,CTout);

   v := @Nam.TabVoies[i];

   WrtScr(v^.CStr,ColInfo,i+LVoies,CTout);

   If v^.LastIn<>0 Then
    Begin
     WrtDt(v^.LastIn,ColIn,i+LVoies,CTout);
     WrtDt(Byte(TabRoto[v^.Roto]),ColRoto,i+LVoies,CTout);
    End;
   If v^.LastOut<>0 Then WrtDt(v^.LastOut,ColOut,i+LVoies,CTout);

   If v^.ComOn Then
    If v^.Dispo Then WrtDt(CarComOn,ColAct,i+LVoies,CRvs) { CTout) }
    Else WrtDt(CarComWait,ColAct,i+LVoies,CRvs); { CTout); }

   WrtDt(Byte(''),39,i+LVoies,CRien);
  End;

 WrtScr(' V   Information d''appel  (--- Ko)    ',0,NbVoies+LVoies,CRvs);

 FillZc(1,NbVoies+LVoies+1,38,ScrHi-2-(NbVoies+LVoies),Byte(' '),CRien);

 For i := NbVoies+LVoies+1 To ScrHi-2 Do
  Begin
   WrtDt(Byte(''),0,i,CRien);
   WrtDt(Byte(''),39,i,CRien);
  End;

 WrtScr('      Alt-X Quitter  Alt-0..P Voie     ',0,ScrHi-1,CRvs);

 If ScrHi>25 Then
  Begin
   FillZc(40,25,40,1,Byte('~'),CRvs);
   FillZc(40,26,40,ScrHi-26,Byte(' '),CRvs);
  End;
End;


Const
     RIEN        = 32; { 250; }
     CarGraphik  = 240;
     BasePanel   = Trait+Stable;


Procedure NoEgaVdtChar( c : Char; x, y : Byte; Attr : Word;
                        Reverse, CadreEvol : Boolean );
Var pix : DtScr_Rec;
Begin
 If (y=0) And (x>=36) And (x<=38) Then
  Begin { spcial ! }
   If (x=36) Or (x=37) Then
    Begin
     pix.car := Byte(' ');
     pix.att := TNet;
    End
   Else
    Begin
     pix.car := Byte('C');
     pix.att := CRvs;
    End;
  End
 Else
  If Reverse Then
   Begin
     if c=#0 then
       begin
         pix.car := RIEN;
         pix.att := CRienOut;
       end
     else
       begin
         if (Attr and Graphik)=0 then pix.car := Byte(c)
         else pix.car := CarGraphik;
         pix.att := CToutOut;
       end;
   End
  Else
   If CadreEvol Then
    Begin
     if c=#0 then
      Begin
       pix.car := RIEN;
       pix.att := CCadreEvol;
      End
     else
      Begin
       If Attr And DRCS=0 Then pix.att := CCadreEvol
       Else pix.att := CCadreEvolDRCS;
       if (Attr and Graphik)=0 then pix.car := Byte(c)
       Else pix.car := CarGraphik;
      End;
    End
   Else
    Begin
     if c=#0 then
       begin
         pix.car := RIEN;
         pix.att := CRien;
       end
     else
       begin
         if (Attr and Graphik)=0 then pix.car := Byte(c)
         else pix.car := CarGraphik;
         If attr And DRCS=0 Then pix.att := CTout
         Else pix.att := CDRCS;
       End;
    End;
 WrtDt(Byte(pix.car),40+x,y,pix.att);
End;

Procedure EgaVdtChar( c : Char; x, y : Byte; Attr : Word; Reverse : Boolean );
Var pix : DtScr_Rec;
    t, f : Byte;
Begin
 If (y=0) And (x>=36) And (x<=38) Then
  Begin { spcial ! }
   If c=#0 Then Attr := BasePanel;
   If (x=36) Or (x=37) Then
    Begin
     pix.car := Byte(' ');
     pix.att := ((Attr And 56) Shl 1) Or 7;
    End
   Else
    Begin
     pix.car := Byte('C');
     pix.att := 112 Or ((Attr And 56) Shr 3);
    End;
  End
 Else
  if c=#0 then
    begin
      pix.car := RIEN;
      pix.att := CRien;
    end
  else
    begin
      if (Attr and Graphik)=0 then pix.car := Byte(c)
      else pix.car := CarGraphik;
      If attr And DRCS=0 Then
       Begin
        If (Attr And (Inverse+Graphik)=Inverse) Then
          Begin
            Attr := (Attr And Not(7+56)) Or
                    ((Attr And 7) Shl 3) Or
                    ((Attr And 56) Shr 3);
            pix.att := CRvs;  { en attendant... }
          End
        Else pix.att := CTout;

        pix.att := (Attr And 7)+((Attr And 56) Shl 1);
       End
      Else
       Begin
        pix.Att := CDRCS;
        If (Attr And (Inverse+Graphik)=Inverse) Then
         Begin
          Attr := (Attr And Not(7+56)) Or
                  ((Attr And 7) Shl 3) Or
                  ((Attr And 56) Shr 3);
         End;

          pix.att := (Attr And 7)+((Attr And 56) Shl 1);

          If (c<>#$20) And (c<>#$7F) And (c<>Char(Complement)) Then
           Begin
            If Attr And Graphik=0 Then pix.Car := MatGP0+(Byte(c)-32)
            Else pix.Car := MatGP1+(Byte(c)-32);

            pix.Att := pix.Att Or (128+8);
           End
          Else pix.Car := Byte(c);
       End;

      If ((Attr And (Graphik+DRCS))=Graphik) Then
       Begin
        If Attr And Disjoint<>0 Then
         Begin
          If c<Char(32+64) Then
           pix.Car := MatG1D+((Byte(c)-32) And 63)
          Else pix.Car := MatG1D+((Byte(c)-64) And 63);
         End
        Else
         Begin
          If c>=#$40 Then
           Begin
            pix.Car := MatG1+(((Byte(c)-32) And 31) Xor 31);
            pix.att := (pix.att And Not(112+7)) Or
                       (((pix.att And 112) Shr 4)+
                        ((pix.att And 7) Shl 4));
           End
          Else pix.Car := MatG1+((Byte(c)-32) And 31);
         End;

        pix.Att := pix.Att Or 128;
       End;
    end;

 If Reverse Then
  Begin
   f := (pix.att And 112) Shr 4;
   t := (pix.att And 7);
   f := f xor 7;
   t := t xor 7;
   pix.att := (pix.att And Not(112+7)) Or t Or (f Shl 4);
  End;

 If ((pix.att And 112) Shr 4)=(pix.att And 7) Then
  Begin { curseur invisible !!! }
   pix.car := $20;   { remplac par ca ! }
   pix.att := pix.att Xor 7;
  End;

 WrtDt(Byte(pix.car),40+x,y,pix.att);
End;



Procedure _AffVdtChar( c : Char; x, y : Byte; Attr : Word );
Begin
 If VideoEGA Then EgaVdtChar(c,x,y,Attr,FALSE)
 Else NoEgaVdtChar(c,x,y,Attr,FALSE,FALSE);
End;


procedure AffLnShow( Var Ram : VDispRam; iY : Byte );
var iX : Byte;
    c  : VDispRamEl;
begin
 for iX := 0 to ScreenLong-1 do
   begin
     c := Ram[iY,iX];
     _AffVdtChar(c.Car,iX,iY,c.Att);
  end;
end;


procedure AffAllLnShow( Var Ram : VDispRam );
var iY : Byte;
    iX : Byte;
    c  : VDispRamEl;
begin
 for iY := 0 to ScreenHigh-1 do
  for iX := 0 to ScreenLong-1 do
    begin
      c := Ram[iY,iX];
      _AffVdtChar(c.Car,iX,iY,c.Att);
   end;
end;






Procedure EmulToScreen( Ram : PVDispRam; x, y, lg, ht : Byte ); Far;
Var iX, iY : Byte;
    c : Char;
    a : Word;
Begin
 If (Ram<>NIL) And (NamScr<>NIL) And (NamScr^.TabVoies[NamScr^.nVoie].E.Ram=Ram) Then
  Begin
   For iY := y To y+Ht-1 Do
    For iX := x To x+Lg-1 Do
     Begin
      c := Ram^[iY,iX].Car;
      a := Ram^[iY,iX].Att;
      _AffVdtChar(c,iX,iY,a);
     End;
  End;
End;


Procedure EmulToScreenScroll( Ram : PVDispRam; y : Byte; Down : Boolean ); Far;
Var Zn  : Zn_Rec;
Begin
 If (Ram<>NIL) And (NamScr<>NIL) And (NamScr^.TabVoies[NamScr^.nVoie].E.Ram=Ram) Then
  If Down Then
   Begin
    Zn.X  := 40;
    Zn.Y  := Y;
    Zn.Lg := ScreenLong;
    Zn.Ht := ScreenHigh-Y;
    ZnDn(Zn,1,0);
    EmulToScreen(Ram,0,y,ScreenLong,1);
   End
  Else
   Begin
    Zn.X  := 40;
    Zn.Y  := Y;
    Zn.Lg := ScreenLong;
    Zn.Ht := ScreenHigh-Y;
    ZnUp(Zn,1,0);
    EmulToScreen(Ram,0,ScreenHigh-1,ScreenLong,1);
   End;
End;




Procedure RefreshEmulCur( Var E : EmulRec );
Begin
 CurPos(40+E.Situ.X,E.Situ.Y);
 ECurX := E.Situ.X;
 ECurY := E.Situ.Y;
End;


Procedure RAffEcran( Var Nam : NamDef );
Var v : PVoieRec;
    i, j : Byte;
    El : PVDispRamEl;
Begin
 If @Nam<>NamScr Then Exit;

 { effacer petite fenetre }

 FillZc(1,NbVoies+LVoies+1,38,ScrHi-2-(NbVoies+LVoies),Byte(' '),CRien);

 For i := NbVoies+LVoies+1 To ScrHi-2 Do
  Begin
   WrtDt(Byte(''),0,i,CRien);
   WrtDt(Byte(''),39,i,CRien);
  End;

 v := @Nam.TabVoies[Nam.nVoie];
 WrtDt(16,0,Nam.nVoie+LVoies,CTout);
 WrtDt(16,39,Nam.nVoie+LVoies,CTout);



 If v^.ComOn Then
  Begin { Affiche l'etat de l'emulation }

   AffAllLnShow(v^.E.Ram^);

   WrtScr(#24'F1 Fin | '#24'F2 Dispo | '#24'F10 GlDispo',1,NbVoies+LVoies+1,CTout);
   WrtScr('Entre Envoi | Home Somm | PgUp Ret',1,NbVoies+LVoies+2,CTout);
   WrtScr('PgDn Suite | Del Annul | Ins Guide',1,NbVoies+LVoies+3,CTout);
   WrtScr('<- Correction | Shift+Entre #13',1,NbVoies+LVoies+4,CTout);
   WrtScr('Ctrl F10 DRCS',1,NbVoies+LVoies+5,CTout);

   CurBig;
   CurOn;

   RefreshEmulCur(v^.E);

  End
 Else
  Begin { affiche rien }
   ClrZc(40,0,40,25,CRien);

   WrtDt(Byte('F'),78,0,CRvs);

   CdrZc(ColTabCStr,LTabCStr,SizeOf(CallStr)+2,NbCStr+2,CdrTab[1],CRien);

   WrtScr(' Mmoire de codes ',ColTabCStr+7,LTabCStr,CRvs);

   For i := 0 To NbCStr-1 Do
    Begin
     WrtScr(TabCStr[i],ColTabCStr+1,LTabCStr+i+1,CTout);
    End;

   WrtScr(' PgUp  PgDn  ^Entre ',ColTabCStr+4,LTabCStr+NbCStr+1,CRvs);

   WrtScr(#24'F10 GlDispo | Entre Connexion',1,NbVoies+LVoies+1,CTout);
   WrtScr('Syntaxe:RDDTT/NN/P/GG/CCCCCCCCCCCCCCCC',1,NbVoies+LVoies+2,CTout);
   WrtScr('P=Prfixe, DD=Dpartement TT=nTltel',1,NbVoies+LVoies+3,CTout);
   WrtScr('NN=ncompl., P=PCV, GG=GFA',1,NbVoies+LVoies+4,CTout);
   WrtScr('CC..=donnes (nom du service)',1,NbVoies+LVoies+5,CTout);
   WrtScr('Ex.: 69470/00/0/01/SERVICE',1,NbVoies+LVoies+6,CTout);

   CurSmall;
   CurOn;

   WrtDt(17,ColTabCStr,LTabCStr+nCStr+1,CTout);
   WrtDt(17,ColTabCStr+SizeOf(CallStr)+1,LTabCStr+nCStr+1,CTout);

   CurPos(5+Length(v^.CStr),Nam.nVoie+LVoies);
  End;
End;


Procedure ChangeVoie( Var Nam : NamDef; NewVoie : Byte );
Var v : PVoieRec;
Begin
 If @Nam=NamScr Then
  Begin
   WrtDt(Byte(''),0,Nam.nVoie+LVoies,CRien);  { efface ancienne marque }
   WrtDt(Byte(''),39,Nam.nVoie+LVoies,CRien);
   RAff := TRUE;
  End;

 v := @Nam.TabVoies[Nam.nVoie];

 Nam.nVoie := NewVoie;
End;


Procedure ChangeCStr( NewCStr : Byte );
Begin
 WrtDt(Byte(''),ColTabCStr,LTabCStr+NewCStr+1,CRien);
 WrtDt(Byte(''),ColTabCStr+SizeOf(CallStr)+1,LTabCStr+NewCStr+1,CRien);

 nCStr := NewCStr;
End;


Function _ConvertNAB( s : String ) : String;
Var i : Byte;
    p : String[16];
    p2 : String[16];
    NewData : Boolean;
Begin
 i := 1;
 While (i<SizeOf(p)) ANd (i<=Length(s)) And (s[i]<>'*') Do
  Begin
   p[i] := UpCase(s[i]);
   Inc(i);
  End;

 p[0] := Char(i-1);

 p2 := '';
 NewData := FALSE;

 If (i<=length(s)) And (s[i]='*') Then
  Begin
   NewData := TRUE;
   Inc(i);
   While (i<SizeOf(p2)) And (i<=length(s)) Do
    Begin
     Inc(p2[0]);
     p2[length(p2)] := s[i];
     Inc(i);
    End;
  End;


 If ((p[1]<'0') Or (p[1]>'9')) And (NbNab>0) Then
  For i := 0 To NbNab-1 Do
   If p=TabNAB[i].NAB Then
    Begin
     s := TabNAB[i].CStr;
     If NewData Then
      Begin
       i := length(s);
       While (i>0) And (s[i]<>'/') Do Dec(i);
       If (i>0) Then
        Begin
         s := copy(s,1,i)+p2;
        End;
      End;

     Break;
    End;

 _ConvertNAB := s;
End;



Function SeekNAB( s : String ) : String;
Var i : Byte;
Begin
 If ((s[1]<'0') Or (s[1]>'9')) And (NbNab>0) Then
  For i := 0 To NbNab-1 Do
   If s=TabNAB[i].NAB Then
    Begin
     SeekNAB := TabNAB[i].CStr;
     Exit;
    End;
 SeekNAB := s;
End;



Function Extract_ddpp( Var _s; Var ir : Word; Var _d ) : Boolean;
Var saisie : Array[0..10000] Of Char Absolute _s;
    ddpp : String Absolute _d;
    i : Word;
Begin
 ddpp[0] := #0;
 If (saisie[ir]='#') Then
  Begin
   Inc(ir);
   i := 0;
   While(i<4) Do
    Begin
     If (saisie[ir]<'0') Or (saisie[ir]>'9') Then
      Begin
       Extract_ddpp := FALSE;
       Exit;
      End;
     ddpp[i+1] := saisie[ir];
     Inc(i);
     Inc(ir);
    End;
   ddpp[0] := Char(i);
   If (saisie[ir]<>'*') Then
    Begin
     Extract_ddpp := FALSE;
     Exit;
    End;
  End;

 Extract_ddpp := TRUE;
End;


Function nabnc_trad( Var _s; Var ir : Word; Var nab : String;
                     Var nc : String; Var nc_exist : Boolean; Var dc : String ) : Boolean;
Var saisie : Array[0..10000] Of Char Absolute _s;
    n : String[56];
    something : Boolean;
    i : Word;
    z : LongInt;
    allnum : Boolean;
Begin
 something := FALSE;

 If (saisie[ir]='*') Then Inc(ir);

 z := 0;
 i := 0;
 allnum := TRUE;

 While( (saisie[ir]<>#0) And (saisie[ir]<>'*') And (i<(SizeOf(n)-1)) ) Do
  Begin
   If (saisie[ir]>' ') And (saisie[ir]<#127) Then
    Begin
     something := TRUE;
     If (allnum) Then
      If (saisie[ir]>='0') And (saisie[ir]<='9') And (i<6) Then
       Begin
        z := z*10+Byte(saisie[ir])-Byte('0');
        if (z>=32768) Then allnum := FALSE;
       End
      Else allnum := FALSE;
     Inc(i);
     n[i] := UpCase(saisie[ir]);
    End;
   Inc(ir);
  End;

 n[0] := Char(i);

 While(saisie[ir]<>#0) Do
  Begin
   Inc(ir);
   If (saisie[ir-1]='*') Then break;
  End;

 i := 0;
 While (saisie[ir]<>#0) And (i<16)  Do
  Begin
   If (saisie[ir]>' ') And (saisie[ir]<#127) Then
    Begin
     something := TRUE;
     Inc(i);
     dc[i] := saisie[ir];
    End;
   Inc(ir);
  End;

 dc[0] := Char(i);

 If Not(Something) Then
  Begin
   nabnc_trad := FALSE;         { y a rien!!! }
   Exit;
  End;

 If allnum Then
  Begin
   nab[0] := #0;
   nc := n;
   nc_exist := TRUE;
  End
 Else
  Begin
   nab := n;
   nc[0] := #0;
   nc_exist := FALSE;
  End;

 nabnc_trad := TRUE;
End;


Procedure str_t_appel( Var Dest : String; Var ddpp : String; Var nc : String; Var dc : String );
Var s : String[20];
Begin
 Dest := '6';
 If (ddpp<>'') Then Dest := Dest+ddpp
 Else Dest := Dest+'0082';
 Dest := Dest+'/'+nc+'/0/00/'+dc;
End;


Function Make_t_Appel( Var s : String; Var t : String ) : Boolean;
Var ddpp : String[8];
    nab : String[50];
    nc : String[20];
    dc : String[20];
    nc_exist : Boolean;
    ir : Word;
    _s : Array[0..256] Of Char;
    result : String[50];
    i : Word;
Begin

(*
 If (s<>'') And (s[1]='.') Then
  Begin
   t := ConvertNAB(s);
   Make_t_Appel := TRUE;
   Exit;
  End;
*)

 ir := 0;
 move(s[1],_s,length(s));
 _s[length(s)] := #0;

 If (Extract_ddpp(_s,ir,ddpp)) Then
  Begin
   If (nabnc_trad(_s,ir,nab,nc,nc_exist,dc)) Then
    Begin
     If (nc_exist) Then
      Begin
       str_t_appel(t,ddpp,nc,dc);
       Make_t_Appel := TRUE;
       Exit;
      End
     Else
       Begin
        result := SeekNab(nab);
        If (dc<>'') Then
         Begin
          i := Length(result);
          While (i>0) And (result[i]<>'/') Do Dec(i);
          If (i>0) Then
           Begin
            result[0] := Char(i);
            t := result+dc;
           End
          Else t := result;
         End
        Else t := result;

        { essayer modifier 6DDPP... }
        If (ddpp<>'') And (Length(t)>=5) And (t[1]='6') Then
         Begin
          t[2] := ddpp[1];
          t[3] := ddpp[2];
          t[4] := ddpp[3];
          t[5] := ddpp[4];
         End;
        Make_t_appel := TRUE;
        Exit;
       End;
    End;
  End;

 Make_t_Appel := FALSE;
End;


Function ConvertNAB( s : String ) : String;
Var Dest : String;
Begin
 If Make_t_Appel(s,Dest) Then
  Begin
   ConvertNAB := Dest;
  End
 Else ConvertNAB := _ConvertNAB(s);
End;


Procedure ClrLink_Sys( Var Sys : MinSys; cause, diag : Byte );
Begin
 CheckRefresh(Sys.Nam^);
 Sys.Link := FALSE;
 Sys.LibCause := cause;
 Sys.LibDiag := diag;
 Sys.iPos := 200;     { fin du lien! }
 Sys.Nam := NIL;
 Sys.Voie := NIL;
End;

Procedure ClrLink( Var v : VoieRec; cause, diag : byte );
Var i, j : Byte;
    m : PMinDef;
    p : PPavDef;
    z : PPavMinDef;
Begin
 For i := 1 To MinMax Do
  If (TMin[i]<>NIL) Then
   Begin
    m := TMin[i];
    If (m^.Sys.cvon) And (m^.Sys.Link) And (m^.Sys.Voie=@v) Then
     Begin
      If EnReso Then v.CStr := ''
      Else v.CStr := v.SaveCStr;
      ClrLink_Sys(m^.Sys,cause,diag);
     End;
   End;

 For j := 1 To PavMax Do
  If (TPav[j]<>NIL) Then
   Begin
    p := TPav[j];
    For i := 1 To p^.PCfg.MinMax Do
     Begin
      z := p^.TMin[i];
      If (z^.Sys.cvon) And (z^.Sys.Link) And (z^.Sys.Voie=@v) Then
       Begin
        If EnReso Then v.CStr := ''
        Else v.CStr := v.SaveCStr;
        ClrLink_Sys(z^.Sys,cause,diag);
       End;
     End;
   End;
End;


Procedure _SendTrame( Var Nam : NamDef; nv : Byte; TM : Byte; Var p; len : Word );
Begin
 Nam.Com._PutTrame(nv+CVBase,TM,p,len);
 If (TM<>A_RESO) Then
  Begin
   Nam.TabVoies[nv].LastOut := TM;
   If @Nam=NamScr Then WrtDt(TM,ColOut,nv+LVoies,CTout);
  End;
End;


Procedure SendTrame( Var Nam : NamDef; nv : Byte; TM : Byte; Var Don : String );
Begin
 _SendTrame(Nam,nv,TM,Don[1],length(Don));
End;


Procedure GlobalDispo( Var Nam : NamDef );
Var s : String[1];
Begin
 s := '';
 Nam.Com.PutTrame(CVBase,A_DISPNAM,s);
 If @Nam=NamScr Then WrtDt(Byte(' '),ColGlDispo,LGlDispo,CRvs);
End;

Procedure GlobalInDispo( Var Nam : NamDef );
Var s : String[1];
Begin
 s := '';
 Nam.Com.PutTrame(CVBase,A_INDINAM,s);
 If @Nam=NamScr Then WrtDt(CarGlDispo,ColGlDispo,LGlDispo,CRvs+128);
End;


Procedure SendDon( Var Sys : MinSys; Var p; lg : Word );
Begin
 PaqSendData(Sys.PaqOut,p,lg);
End;


Procedure SendExtra( Var Sys : MinSys; TM : Byte );
Var s : String;
Begin

 s := POSLZ+#27#93;

 Case TM Of
  A_ERRM : s := s+'ERREUR MULTIPLEXAGE'#10;
  A_INDI : s := s+'VOIE INDISPONIBLE'#10;
  A_DISP : s := s+'VOIE DISPONIBLE'#10;
 Else s := s+'TRAME: '+Byte2Hex(TM)+#10;
 End;

 PaqSendData(Sys.PaqOut,s[1],length(s));
End;


Procedure LinkTrameExtra( Var v : VoieRec; TM : Byte );
Var i, j : Byte;
    m : PMinDef;
    p : PPavDef;
    z : PPavMinDef;
Begin
 For i := 1 To MinMax Do
  If TMin[i]<>NIL Then
   Begin
    m := TMin[i];
    If (m^.Sys.cvon) And (m^.Sys.Link) And (m^.Sys.Voie=@v) Then
     Begin
      SendExtra(m^.Sys,TM);
     End;
   End;

 For j := 1 To PavMax Do
  If (TPav[j]<>NIL) Then
   Begin
    p := TPav[j];
    For i := 1 To p^.PCfg.MinMax Do
     Begin
      z := p^.TMin[i];
      If (z^.Sys.cvon) And (z^.Sys.Link) And (z^.Sys.Voie=@v) Then
       Begin
        SendExtra(z^.Sys,TM);
       End;
     End;
   End;
End;


Procedure ErrMulti( Var Nam : NamDef; nv : Byte );
Var s : String[1];
Begin
 If (nv<NbVoies) Then
  Begin
   s := #$30;
   SendTrame(Nam,nv,A_ERRM,s);
   LinkTrameExtra(Nam.TabVoies[nv],A_ERRM);
  End;
End;

Procedure LinkTrameDON( Var v : VoieRec; Var p; lg : Word );
Var i, j : Byte;
    m : PMinDef;
    pv : PPavDef;
    z : PPavMinDef;
Begin
 For i := 1 To MinMax Do
  If TMin[i]<>NIL Then
   Begin
    m := TMin[i];
    If (m^.Sys.cvon) And (m^.Sys.Link) And (m^.Sys.Voie=@v) Then
     Begin
      SendDon(m^.Sys,p,lg);
     End;
   End;

 For j := 1 To PavMax Do
  If (TPav[j]<>NIL) Then
   Begin
    pv := TPav[j];
    For i := 1 To pv^.PCfg.MinMax Do
     Begin
      z := pv^.TMin[i];
      If (z^.Sys.cvon) And (z^.Sys.Link) And (z^.Sys.Voie=@v) Then
       Begin
        SendDon(z^.Sys,p,lg);
       End;
     End;
   End;
End;

Procedure LinkTrameCOMM( Var v : VoieRec );
Var i, j : Byte;
    m : PMinDef;
    p : PPavDef;
    z : PPavMinDef;
Begin
 For i := 1 To MinMax Do
  If TMin[i]<>NIL Then
   Begin
    m := TMin[i];
    If (m^.Sys.cvon) And (m^.Sys.Link) And (m^.Sys.Voie=@v) Then
     Begin
      (* rien a faire??? *)
     End;
   End;

 For j := 1 To PavMax Do
  If (TPav[j]<>NIL) Then
   Begin
    p := TPav[j];
    For i := 1 To p^.PCfg.MinMax Do
     Begin
      z := p^.TMin[i];
      If (z^.Sys.cvon) And (z^.Sys.Link) And (z^.Sys.Voie=@v) Then
       Begin
        (* euh??? *)
       End;
     End;
   End;
End;

(* depuis le 31/08/93 ...

Procedure LinkTrameLIB( Var v : VoieRec );
Var i : Byte;
    m : PMinDef;
Begin
 For i := 1 To MinMax Do
  If TMin[i]<>NIL Then
   Begin
    m := TMin[i];
    If (m^.Sys.cvon) And (m^.Sys.Link) And (m^.Sys.Voie=@v) Then
     Begin
      If (m^.Sys.Ph=COMPH_CNX) And (m^.Sys.Ph2 in [CNX_ONLINE_WAIT,CNX_ONLINE]) Then
       Begin
        m^.Sys.Ph2 := CNX_ONLINE_END;
        m^.Sys.LibCause := 0;
        m^.Sys.LibDiag := $FF;
       End;
     End;
   End;
End;
*)

Procedure LinkTrameLIB( Var v : VoieRec );
Begin
 ClrLink(v,0,$FF);
End;


Procedure Emul( Var v : VoieRec; c : Char );
Begin
 EmulM2.Emul(v.E,c);
End;


Procedure EmulStr( Var v : VoieRec; Texte : String );
Var i : Byte;
Begin
 For i := 1 To Length(Texte) Do Emul(v,Texte[i]);
End;


Procedure _NewTrameCOMM( Var Nam : NamDef; nv : Byte );
Var v  : PVoieRec;
    s  : String;
Begin
 If (nv<NbVoies) And Not(Nam.TabVoies[nv].ComOn) Then
  Begin
   v := @Nam.TabVoies[nv];

   { Prparer l'emulateur }

   New(v^.E.Ram);
   If v^.E.Ram=NIL Then Exit;

   ClearRam(v^.E.Ram);
   If Nam.NCfg.UseDRCS Then
    Begin
     New(v^.E.DRCS);
     If v^.E.DRCS=NIL Then
      Begin
       Dispose(v^.E.Ram);
       v^.E.Ram := NIL;
       Exit;
      End;
     ClearRamDRCS(v^.E.DRCS);
    End
   Else v^.E.DRCS := NIL;


   v^.ComOn := TRUE;
   v^.Dispo := TRUE;

   LinkTrameCOMM(v^);

   If @Nam=NamScr Then WrtDt(CarComOn,ColAct,nv+LVoies,CRvs); { CTout); }

   InitEmul(v^.E,v^.E.Ram,v^.E.DRCS);

   s := #12#31'@A'#24#10'communication '#25#66'etablie';
   EmulStr(v^,s);
   LinkTrameDon(v^,s[1],length(s));

   v^.Input := '';

   If (@Nam=NamScr) And (nv=Nam.nVoie) Then RAff := TRUE;

  End
 Else ErrMulti(Nam,nv);
End;


Procedure NewTrameCOMM( Var Nam : NamDef );
Begin
 _NewTrameCOMM(Nam,Byte(Nam.Com.C_NT-CVBase));
End;


Procedure NewTrameLIB( Var Nam : NamDef );
Var nv : Byte;
    v  : PVoieRec;
Begin
 nv := Byte(Nam.Com.C_NT-CVBase);
 If (nv<NbVoies) Then
  Begin
   If Nam.TabVoies[nv].ComOn Then
    Begin
     v := @Nam.TabVoies[nv];

     LinkTrameLIB(v^);

     v^.ComOn := FALSE;

     If @Nam=NamScr Then WrtDt(Byte(' '),ColAct,nv+LVoies,CTout);

     { Virer l'emulateur }

     Dispose(v^.E.Ram);
     v^.E.Ram := NIL;
     If v^.E.DRCS<>NIL Then
      Begin
       Dispose(v^.E.DRCS);
       v^.E.DRCS := NIL;
      End;

     If (@Nam=NamScr) And (nv=Nam.nVoie) Then RAff := TRUE;

    End;
  End
 Else ErrMulti(Nam,nv);
End;



Procedure SubstSlash( Var s : String );
Var len, i : Integer;
Begin
 len := Length(s);
 For i := 1 To len Do If (s[i]='/') Then s[i] := '\';
End;


Procedure DoSubst( Var s : String );
Var lo, i : Integer;
    Ok : Boolean;
Begin
 If (SUBST_Old<>'') And (Length(s)>=Length(SUBST_Old)) Then
  Begin
   lo  := Length(SUBST_Old);
   Ok := TRUE;
   For i := 1 To lo Do
    Begin
     If (UpCase(s[i])<>UpCase(SUBST_Old[i])) Then
      Begin
       Ok := FALSE;
       Break;
      End;
    End;

   If Ok Then
    Begin
     s := SUBST_New+Copy(s,lo+1,length(s)-lo);
    End;
  End;
End;



Procedure EmulFermicFile( Var Nam : NamDef; Var v : VoieRec );
Var f : File;
    buf : Array[1..1024] Of Char;
    lgbuf : Word;
    Name : String;
    i, j : Word;
    s : String;
    max : Word;
Begin
 If Nam.Com.C_LgDon-3>SizeOf(String)-1 Then lgbuf := SizeOf(String)-1
 Else lgbuf := Nam.Com.C_LgDon-3;
 move(Nam.Com.C_Don[3],Name[1],lgbuf);
 Name[0] := Char(lgbuf);
 If Name<>'' Then
  Begin
   j := 1;
   While(j<=lgbuf) Do
    Begin
     s[0] := Char(0);
     While( (j<=lgbuf) And (Name[j]<>';') ) Do
      Begin
       Inc(s[0]);
       s[length(s)] := Name[j];
       Inc(j);
      End;

     While( (j<=lgbuf) And (Name[j]=';') ) Do Inc(j);

     If (s<>'') Then
      Begin

       SubstSlash(s);

       DoSubst(s);

       Assign(f,s);
       Reset(f,1);
       If IoResult=0 Then
        Begin
         max := 0;
         While Not(Eof(f)) And (max<SIZEMAXFILE) Do
          Begin
           BlockRead(f,buf,SizeOf(buf),lgbuf);
           For i := 1 To lgbuf Do Emul(v,buf[i]);
           LinkTrameDon(v,buf,lgbuf);
           inc(max,lgbuf);
          End;
         Close(f);
         Exit;
        End;

      End;
    End;
  End;
 s := #30#27#93#27#70'INEXISTANT '#27#71+Name+#24;
 EmulStr(v,s);
 LinkTrameDon(v,s[1],length(s));
End;


Procedure StrangeTrame( Var Nam : NamDef );
Var nv : Byte;
    v  : PVoieRec;
    t, s : String;
    i  : Word;
    lg : Word;
    c  : Char;
Begin
 nv := Byte(Nam.Com.C_NT-CVBase);
 If (nv<NbVoies) And Nam.TabVoies[nv].ComOn Then
  Begin
   v := @Nam.TabVoies[nv];

   Case Nam.Com.C_TM Of
      A_EDIT : t := 'EDIT';
      A_ENDR : t := 'ENDR';
      A_ROUT : t := 'ROUT';
    Else t := '????';
   End;

   s := #30#27#93#27#70'TM: '#27#71+' '+t+' (0x'+Byte2Hex(Nam.Com.C_TM)+') : ';
   EmulStr(v^,s);
   LinkTrameDon(v^,s[1],length(s));

   if (Nam.Com.C_LgDon>40) Then lg := 40
   else lg := Nam.Com.C_LgDon;

   For i := 1 To lg Do
    Begin
     c := Char(Nam.Com.C_Don[i-1]);
     if ( (c<#32) Or (c>#127) ) Then c := '?';
     t[i] := c;
    End;

   t[lg+1] := #24;
   t[0] := Char(lg+1);

   EmulStr(v^,t);
   LinkTrameDon(v^,t[1],length(t));
  End
 Else ErrMulti(Nam,nv);
End;


Procedure NewTrameDON( Var Nam : NamDef );
Var nv : Byte;
    v  : PVoieRec;
    i  : Word;
Begin
 nv := Byte(Nam.Com.C_NT-CVBase);
 If (nv<NbVoies) And Nam.TabVoies[nv].ComOn Then
  Begin
   v := @Nam.TabVoies[nv];

   If Fermic And (Nam.Com.C_LgDon>=3) And
      (Nam.Com.C_Don[0]=27) And (Nam.Com.C_Don[1]=27) And (Nam.Com.C_Don[2]=27) Then
    Begin
     EmulFermicFile(Nam,v^);
    End
   Else
    Begin
     { emuler les donnes }

     For i := 1 To Nam.Com.C_LgDon Do Emul(v^,Char(Nam.Com.C_Don[i-1]));
     LinkTrameDon(v^,Nam.Com.C_Don,Nam.Com.C_LgDon);
    End;
  End
 Else ErrMulti(Nam,nv);
End;


{ Reception d'une trame  analyser }

Procedure NewTrame( Var Nam : NamDef );
Var nv : Byte;
    v  : PVoieRec;
    dest : PNamDef;
    pav : PPavDef;
Begin
 { affich ce qui a t recu (si possible) }

 nv := Byte(Nam.Com.C_NT-CVBase);

 If Nam.Com.C_TM=A_RESO Then
  Begin
   { Trame de "reso" venant d'un NAM !!! }
   { on teste si pas a destination d'un autre NAM ... }
   { sinon, on renvoi sur le PAV numro R2F_nPAV }

   If (nv>=RLOG_BASE) And (nv<(RLOG_BASE+NamMax)) Then
    Begin
     { c'est pour un autre NAM !!! }
     dest := TNam[nv-RLOG_BASE+1];

     If (dest<>NIL) And (Nam.nNam<>dest^.nNam) Then
      Begin
       { et on peut pas faire boucler!!!! }
       _SendTrame(dest^,nv,A_RESO,Nam.Com.C_Don,Nam.Com.C_LgDon);
      End;
    End
   Else
    Begin
     { c'est pour le routeur ... qui est vers le PAV... }
     If (R2F_nPAV>=1) And (R2F_nPAV<=PavMax) Then
      Begin
       pav := TPav[R2F_nPAV];
       If (pav<>NIL) Then
        Begin
         pav^.Com._PutTrame(nv+CVBase,A_RESO,Nam.Com.C_Don,Nam.Com.C_LgDon);
        End;
      End;
    End;
  End
 Else
  Begin
   If (nv<NbVoies) Then
    Begin
      v := @Nam.TabVoies[nv];
      v^.LastIn := Nam.Com.C_TM;
      If @Nam=NamScr Then WrtDt(Nam.Com.C_TM,ColIn,nv+LVoies,CTout);
      Inc(v^.Roto);
      If v^.Roto>=4 Then v^.Roto := 0;
      If @Nam=NamScr Then WrtDt(Byte(TabRoto[v^.Roto]),ColRoto,nv+LVoies,CTout);
    End
   Else Beep;

   Case Nam.Com.C_TM Of
    A_COMM : NewTrameCOMM(Nam);
    A_LIB  : NewTrameLIB(Nam);
    A_DON  : Begin
  (*
              If (Nam.NCfg.CnxAuto) And (nv<NbVoies) And Not(Nam.TabVoies[nv].ComOn) Then NewTrameCOMM(Nam);
  *)
              NewTrameDON(Nam);
             End;
    Else
     Begin
      StrangeTrame(Nam);
     End;
   End;
  End;
End;


Const TabALT1 : Array[16..25] Of Char = ('Q','W','E','R','T','Y','U','I','O','P');
      TabALT2 : Array[30..38] Of Char = ('A','S','D','F','G','H','J','K','L');
      TabALT3 : Array[44..50] Of Char = ('Z','X','C','V','B','N','M');

Function ScanALT(c : Char) : Byte;
Begin
  If (c>=#120) And (c<=#128) Then ScanALT := Byte(c)-119
  Else
   If c=#129 Then ScanALT := 0
   Else
    If (c>=#16) And (c<=#25) Then ScanALT := Byte(TabALT1[Byte(c)])-Byte('A')+10
    Else
      If (c>=#30) And (c<=#38) Then ScanALT := Byte(TabALT2[Byte(c)])-Byte('A')+10
      Else
        If (c>=#44) And (c<=#50) Then ScanALT := Byte(TabALT3[Byte(c)])-Byte('A')+10
        Else ScanALT := $FF;
End;


Function IsNoConnect : Boolean;
Var n : PNamDef;
    i, j : Byte;
Begin
 For i := 1 To NamMax Do
  Begin
   n := TNam[i];
   If n<>NIL Then
    Begin
     For j := 0 To NbVoies-1 Do
      If n^.TabVoies[j].ComOn Then
       Begin
        IsNoConnect := FALSE;
        Exit;
       End;
    End;
  End;
 IsNoConnect := TRUE;
End;

Procedure ChangeUpVoie( Var Nam : NamDef );
Var NewVoie : Byte;
Begin
 NewVoie := Nam.nVoie;
 If NewVoie=0 Then NewVoie := NbVoies-1
 Else Dec(NewVoie);
 ChangeVoie( Nam, NewVoie );
End;

Procedure ChangeDownVoie( Var Nam : NamDef );
Var NewVoie : Byte;
Begin
 NewVoie := Nam.nVoie;
 Inc(NewVoie);
 If NewVoie>=NbVoies Then NewVoie := 0;
 ChangeVoie( Nam,  NewVoie );
End;

Function ChangeNam( NewNam : Byte ) : Boolean;
Begin
 If TNam[NewNam]<>NIL Then
  Begin
   NamScr := TNam[NewNam];
   Refresh := TRUE;
   ChangeNam := TRUE;
  End
 Else ChangeNam := FALSE;
End;

Function MainKey( Var Nam : NamDef; Key : Char; Funct : Boolean ) : Boolean;
Var AltCode : Byte;
    squit   : Word;
    n       : Word;
Begin
 MainKey := TRUE;
 squit := HowQuit;
 HowQuit := 0;

 If Funct Then AltCode := ScanALT( Key )
 Else AltCode := $FF;

 If AltCode<>$FF Then
  Begin
   If AltCode<NbVoies Then { Chang de voie }
    Begin
     ChangeVoie( Nam, AltCode );
    End
   Else
    If (Key=#45) Or (Key=#16) Then { ALT X ou ALT Q }
     Begin
      HowQuit := squit;
      Inc(HowQuit);

      If IsNoConnect Or (HowQuit>=5) Then EndMain := TRUE
      Else
       Begin { il y a encore des voies actives, on ne peut sortir !! }
        Beep;
       End;
     End
    Else Beep;
  End
 Else
  Begin
   If Funct Then
    Case Key Of
     #104..Char(104+NamMax-1) :
           Begin { Alt+F1...Alt+F8  Nam 1...8 }
            n := Byte(Key)-104+1;
            If Not(ChangeNam(n)) Then Beep;
           End;
     #72 : Begin  { Cur Haut }
            ChangeUpVoie(Nam);
           End;
     #80 : Begin  { Cur Bas }
            ChangeDownVoie(Nam);
           End;
     #93 : If Nam.GlDispo Then
            Begin
             GlobalInDispo(Nam);
             GlobalInDispo(Nam);  { une 2eme fois }
             Nam.GlDispo := FALSE;
            End
           Else
            Begin
             GlobalDispo(Nam);
             Nam.GlDispo := TRUE;
            End;
    Else MainKey := FALSE;
    End
   Else MainKey := FALSE;
  End;

End;


Procedure SendTrameTche( Var Nam : NamDef; nv : Byte; Tche : Char );
Var v : PVoieRec;
    s : String;
Begin
 v := @Nam.TabVoies[nv];
 If Length(v^.Input)=SizeOf(v^.Input)-2 Then
  Begin
   SendTrame(Nam,nv,A_DON,v^.Input);
   LinkTrameDon(v^,v^.Input[1],length(v^.Input));
   v^.Input := '';
  End;

 If tche=#0 Then s := v^.Input+#13 Else s := v^.Input+Tche+#13;
 SendTrame(Nam,nv,A_DON,s);
 LinkTrameDon(v^,v^.Input[1],length(v^.Input));

 v^.Input := '';
End;


Procedure SendLIB( Var Nam : NamDef; nv : Byte; p1, p2 : Byte );
Var v : PVoieRec;
    s : String;
Begin
 v := @Nam.TabVoies[nv];

 s := Byte2Hex(p1)+'/'+Byte2Hex(p2);

 SendTrame(Nam,nv,A_LIB,s);

 v^.ComOn := FALSE;

 If @Nam=NamScr Then WrtDt(Byte(' '),ColAct,nv+LVoies,CTout);

 { Virer le minitel connect }

 ClrLink(v^,p1,p2);

 { Virer l'emulateur }

 Dispose(v^.E.Ram);
 v^.E.Ram := NIL;
 If v^.E.DRCS<>NIL Then
  Begin
   Dispose(v^.E.DRCS);
   v^.E.DRCS := NIL;
  End;

 If (@Nam=NamScr) And (nv=Nam.nVoie) Then RAff := TRUE;
End;


Procedure EmulKey( Var Nam : NamDef; Key : Char; Funct : Boolean );
Var v : PVoieRec;
    Reg : Registers;
Begin
 v := @Nam.TabVoies[Nam.nVoie];

 If Not(Funct) Then
  Case Key Of
   #8  : Begin  { Correction }
          If Length(v^.Input)=0 Then
            SendTrameTche(Nam,Nam.nVoie,T_CORRECTION)
          Else
           Begin
            Dec(v^.Input[0]);
            EmulStr(v^,#8' '#8);
           End;
         End;
   #13 : Begin { #13 => Envoi   Shift+#13 => Return ! }
          Reg.AH := $02;
          Intr($16,Reg);
          If Reg.AL And 3<>0 Then
           Begin
            SendTrameTche(Nam,Nam.nVoie,#0);
           End
          Else SendTrameTche(Nam,Nam.nVoie,T_ENVOI);
         End;
  Else
   If Key>=#128 Then Beep
   Else
    Begin
     Inc(v^.Input[0]);
     v^.Input[Length(v^.Input)] := Key;
     Emul(v^,Key);
     If Length(v^.Input)=SizeOf(v^.Input)-1 Then
      Begin { vider buffer }
       SendTrame(Nam,Nam.nVoie,A_DON,v^.Input);
       LinkTrameDon(v^,v^.Input[1],length(v^.Input));
       v^.Input := '';
      End;
    End;
  End
 Else
  Case Key Of
   #71 : SendTrameTche(Nam,Nam.nVoie,T_SOMMAIRE);   { Home }
   #73 : SendTrameTche(Nam,Nam.nVoie,T_RETOUR);     { PgUp }
   #79 : SendTrameTche(Nam,Nam.nVoie,T_REPETITION); { End }
   #81 : SendTrameTche(Nam,Nam.nVoie,T_SUITE);      { PgDn }
   #82 : SendTrameTche(Nam,Nam.nVoie,T_GUIDE);      { Ins }
   #83 : SendTrameTche(Nam,Nam.nVoie,T_ANNULATION); { Del }
   #84 : SendLIB(Nam,Nam.nVoie,CAUSE_PAV,$01);      { Shift+F1 : deconnecte }
   #85 : If v^.Dispo Then
          Begin
           SendTrame(Nam,Nam.nVoie,A_INDI,EmptyStr);
           v^.Dispo := FALSE;
           If @Nam=NamScr Then WrtDt(CarComWait,ColAct,Nam.nVoie+LVoies,CRvs); { CTout); }
           LinkTrameExtra(v^,A_INDI);
          End
         Else
          Begin
           SendTrame(Nam,Nam.nVoie,A_DISP,EmptyStr);
           v^.Dispo := TRUE;
           If @Nam=NamScr Then WrtDt(CarComOn,ColAct,Nam.nVoie+LVoies,CRvs); { CTout); }
           LinkTrameExtra(v^,A_DISP);
          End;
   #103: Begin { Ctrl F10 : telecharge le DRCS }
          If @Nam=NamScr Then
           Begin
            If v^.E.DRCS<>NIL Then
             Begin
              LoadMatrice(v^.E.DRCS^[0],94,1,MatGP0+1);
              LoadMatrice(v^.E.DRCS^[1],94,1,MatGP1+1);
              ResetVideoEGA;
             End
            Else Beep;
           End;
         End;
  Else Beep;
  End;
End;


Function GetUnit( Var s : String; Pos : Byte;
                  Var u : Byte ) : Boolean;
Var b : Byte;
Begin
 If (Pos>0) And (Pos<=Length(s)) Then
  Begin
   b := Byte(Byte(s[Pos])-Byte('0'));
   If b<=9 Then
    Begin
     u := b;
     GetUnit := TRUE;
     Exit;
    End;
  End;
 GetUnit := FALSE;
End;


Function GetSlash( Var s : String; Pos : Byte ) : Boolean;
Begin
 GetSlash := (Pos>0) And (Pos<=Length(s)) And (s[Pos]='/');
End;


{ Fac FF/ }
{ Renvoi Result=-1 si absent }

Function GetFac( SizeFac : Byte; Var s : String; Var Pos : Byte;
                 Var Result : Integer ) : Boolean;
Var R : Integer;
Begin
 If (Pos>0) And (Pos<=Length(s)) Then
  Begin
   If s[Pos]='/' Then
    Begin
     Inc(Pos);
     Result := -1;
     GetFac := TRUE;
     Exit;
    End;

   If Pos+SizeFac<=Length(s) Then
    Begin
     R := 0;
     While (SizeFac>0) And (s[Pos]>='0') And (s[Pos]<='9') Do
      Begin
       R := R*10+(Byte(s[Pos])-Byte('0'));
       Dec(SizeFac);
       Inc(Pos);
      End;
     If (SizeFac=0) And (s[Pos]='/') Then
      Begin
       Result := r;
       Inc(Pos);
       GetFac := TRUE;
       Exit;
      End;
    End;
  End;
 GetFac := FALSE;
End;


{ tente d'envoyer un appel }
{ 69482/00/0/00/1234567890123456 => 69400000082/00/0/00/... }
{ ou 6942//// }

Function ExecCall( Var Nam : NamDef; nVoie : Byte ) : Boolean;
Var Org : Byte;
    Dep : Byte;
    Abo : Longint;
    TX  : Byte;
    nc  : Integer;
    pcv : Integer;
    gfa : Integer;
    v   : PVoieRec;
    pos : Byte;
    u   : Byte;
    don : String[16];
    s   : String[32];
Begin
 v := @Nam.TabVoies[nVoie];
 pos := 1;
 If GetUnit(v^.CStr,pos,Org) Then
  Begin
   Inc(pos);
   If GetUnit(v^.CStr,pos,Dep) And
      GetUnit(v^.CStr,pos+1,u) Then
    Begin
     Dep := (Dep*10)+u;
     Inc(pos,2);

     Abo := 0;

     If Nam.NCfg.SaisieLibre Then
      Begin
       { compose les vrais donnes d''appel }
       s := Val2Str(Org,1)+Val2Str(Dep,2)+Val2Str(Abo,6);
       While (Length(s)<SizeOf(s)-1) And
             (pos<=Length(v^.CStr)) Do
        Begin
         Inc(s[0]);
         s[Length(s)] := v^.CStr[pos];
         Inc(pos);
        End;

       SendTrame(Nam,nVoie,A_APPEL,s);
       If (Nam.NCfg.CnxAuto) Then _NewTrameCOMM(Nam,nVoie);

       ExecCall := TRUE;
       Exit;
      End
     Else
      Begin
       If GetUnit(v^.CStr,pos,TX) And
          GetUnit(v^.CStr,pos+1,u) And
          GetSlash(v^.CStr,pos+2) Then
        Begin
         TX := (TX*10)+u;
         Inc(pos,3);

         If GetFac( 2, v^.CStr, pos, nc ) And ((nc=-1) Or (nc<=99)) And
            GetFac( 1, v^.CStr, pos, pcv ) And ((pcv=-1) Or (pcv<=1)) And
            GetFac( 2, v^.CStr, pos, gfa ) And ((gfa=-1) Or (gfa<=1)) Then
          Begin
           don := '';
           While (Length(Don)<SizeOf(Don)-1) And
                 (pos<=Length(v^.CStr)) Do
            Begin
             Inc(don[0]);
             don[Length(don)] := v^.CStr[pos];
             Inc(pos);
            End;
           If pos>Length(v^.CStr) Then
            Begin
             { compose les vrais donnes d''appel }
             s := Val2Str(Org,1)+Val2Str(Dep,2)+Val2Str(Abo,6)+
                  Val2Str(TX,2)+'/';

             If nc<>-1 Then s := s+Val2Str(nc,2);
             s := s+'/';

             If pcv<>-1 Then s := s+Val2Str(pcv,1);
             s := s+'/';

             If gfa<>-1 Then s := s+Val2Str(gfa,2);
             s := s+'/'+don;

             SendTrame(Nam,nVoie,A_APPEL,s);
             If (Nam.NCfg.CnxAuto) Then _NewTrameCOMM(Nam,nVoie);

             ExecCall := TRUE;
             Exit;
            End;
          End;
        End;
      End;
    End;
  End;
 ExecCall := FALSE;
End;


Procedure CallKey( Var Nam : NamDef; Key : Char; Funct : Boolean );
Var v : PVoieRec;
    i : Byte;
    NewCStr : Byte;
Begin
 v := @Nam.TabVoies[Nam.nVoie];
 If Funct Then
  Begin
   Case Key Of
    #73 : Begin  { PgUp }
           NewCStr := nCStr;
           If NewCStr=0 Then NewCStr := NbCStr-1
           Else Dec(NewCStr);
           ChangeCStr( NewCStr );
           RAff := TRUE;
          End;
    #81 : Begin  { PgDn }
           NewCStr := nCStr;
           Inc(NewCStr);
           If NewCStr>=NbCStr Then NewCStr := 0;
           ChangeCStr( NewCStr );
           RAff := TRUE;
          End;
   Else Beep;
   End;
  End
 Else
  Begin
   If (Key>='!') And (Key<=#127) Then
    Begin
     If Length(v^.CStr)>=SizeOf(v^.CStr)-1 Then Beep
     Else
      Begin
       Inc(v^.CStr[0]);
       v^.CStr[Length(v^.CStr)] := Key;
       If @Nam=NamScr Then
        Begin
         WrtDt(Byte(Key),ColInfo-1+Length(v^.CStr),Nam.nVoie+LVoies,CTout);
         CurPos(ColInfo+Length(v^.CStr),Nam.nVoie+LVoies);
        End;
      End;
    End
   Else
    Case Key Of
     #8 : Begin { Back Space }
           If Length(v^.CStr)=0 Then Beep
           Else
            Begin
             Dec(v^.CStr[0]);
             If @Nam=NamScr Then
              Begin
               WrtDt(Byte(' '),ColInfo+Length(v^.CStr),Nam.nVoie+LVoies,CRien);
               CurPos(ColInfo+Length(v^.CStr),Nam.nVoie+LVoies);
              End;
            End;
          End;
     #13: Begin
           If v^.CStr='' Then
            { transfert mem->voie }
            If (TabCStr[nCStr]<>'') Then
             Begin
              v^.CStr := TabCStr[nCStr];
              If @Nam=NamScr Then
               Begin
                WrtScr(v^.CStr,ColInfo,Nam.nVoie+LVoies,CTout);
                RAff := TRUE;
               End;
             End
            Else Beep
           Else
            Begin
             CheckRefresh(Nam);
             v^.LastCnxC18 := 0;       (* desactive *)
             v^.SaveCStr := v^.CStr;
             v^.CStr := ConvertNAB(v^.CStr);
             If Not(ExecCall(Nam,Nam.nVoie)) Then Beep;
            End;
          End;
     #25: Begin { Ctrl Y }
           If @Nam=NamScr Then
            Begin
             For i := 1 To Length(v^.CStr) Do
              WrtDt(Byte(' '),ColInfo-1+i,Nam.nVoie+LVoies,CRien);
             CurPos(ColInfo,Nam.nVoie+LVoies);
            End;
           v^.CStr := '';
          End;
    Else Beep;
    End;
  End;
End;


Procedure RefreshCur( Var Nam : NamDef );
Var v : PVoieRec;
Begin
 v := @Nam.TabVoies[Nam.nVoie];
 If @Nam=NamScr Then
  Begin
   If (v^.E.Situ.X<>ECurX) or (v^.E.Situ.Y<>ECurY) Then RefreshEmulCur(v^.E);
  End;
End;

{$I SYSCTRL.PAS }

{$I PAVCTRL.PAS }

{$I MINCTRL.PAS }

Var SaveProc, SaveUp : Pointer;
    tmem : Longint;
    tflash : Longint;
    FON : Boolean;

Procedure MainInit;
Var i : Byte;
Begin

 SaveProc := RamProc.Ptr;
 RamProc.Proc := EmulToScreen;

 SaveUp := ScrollProc.Ptr;
 ScrollProc.Proc := EmulToScreenScroll;

 tmem := 0;

 For i := 1 To NamMax Do
  If TNam[i]<>NIL Then
   Begin
    NamScr := TNam[i];
    Break;
   End;

 tflash := 0;
 FON := FALSE;

 Refresh := TRUE;  { force un reaffichage complet }
 EndMain := FALSE;

End;


Procedure MainDone;
Begin

 If NamScr<>NIL Then FlashON;

 ScrollProc.Ptr := SaveUp;
 RamProc.Ptr := SaveProc;

End;


Procedure Main( KeyAvail : Boolean );
Var i : Byte;
    Key : Char;
    Funct : Boolean;
Begin
(*
 While Not(EndMain) Do
  Begin
*)

   If (NamScr<>NIL) And Refresh Then
    Begin
     RefreshEcran(NamScr^);
     Refresh := FALSE;
     RAff := TRUE;
     tflash := 0;
     tmem := 0;
    End;

   If (NamScr<>NIL) And RAff Then
    Begin
     RAffEcran(NamScr^);
     RAff := FALSE;
    End;

   For i := 1 To NamMax Do
    Begin
     If TNam[i]<>NIL Then
      Begin
       If TNam[i]^.Com.Saisie Then NewTrame(TNam[i]^);
      End;
    End;

   If NamScr<>NIL Then
    Begin
     If KeyAvail And KeyPressed Then
      Begin
       Key := ReadKey;
       If Key=#0 Then
        Begin
         Funct := TRUE;
         Key := ReadKey;
        End
       Else Funct := FALSE;

       If Not(MainKey(NamScr^,Key,Funct)) Then
        Begin
         If NamScr^.TabVoies[NamScr^.nVoie].ComOn Then EmulKey(NamScr^,Key,Funct)
         Else CallKey(NamScr^,Key,Funct);
        End;

      End
     Else
      Begin
       If NamScr^.TabVoies[NamScr^.nVoie].ComOn Then RefreshCur(NamScr^);
       If tmem<=GetC18 Then
        Begin
         MemFree := MemAvail Div 1024;
         tmem := GetC18+18*3;
         WrtScr(_Val2Str(MemFree,3),28,NbVoies+LVoies,CRvs);
        End;
       If tflash<=GetC18 Then
        Begin
         If FON Then FlashOff
         Else FlashON;
         FON := Not(FON);
         tflash := GetC18+(18 Div 2);
         If HeapFail Then
          Begin
           If Not(FON) Then
            Begin
             WrtDt(16,28-1,NbVoies+LVoies,CRvs);
             WrtDt(17,28+6,NbVoies+LVoies,CRvs);
             Beep;
            End
           Else
            Begin
             WrtDt(Byte('('),28-1,NbVoies+LVoies,CRvs);
             WrtDt(Byte(')'),28+6,NbVoies+LVoies,CRvs);
            End;
          End;
        End;
      End;
    End;
(*
   MainPolling;
*)
   MinPolling;
   PavPolling;
   SysPolling;
(*
  End;
*)
End;



Function PresenteSoft : Boolean;
Const X = 18; { Y=6-2-2-1; } Lg=44; Ht=13+NamMax-1+2+1;
Var Key : Char;
    Funct : Boolean;
    j : Byte;
    Y : Byte;
    tk : Longint;
Begin

 CurOff;

 If VideoEGA Then Y := 5
 Else Y := 0; { 1; }

 FillZc(0,0,80,ScrHi,176 {32} { 177 },CRvs {CRien});

 ClrZc(X,Y,Lg,Ht, CRien);
 CdrZc(X,Y,Lg,Ht, CdrTab[2], CRien );

 CdrZc(X+20-3-2-1,+Y+1-1,15+2,3,CdrTab[3],CRien);
 WrtScr('NAMSIM 1.32',X+20-3,Y+2-1,CTout);

{ WrtScr('   1.32    ',X+17,Y+4,CTout); }

 If Fermic Then WrtScr('Copyright (c) 1993 T.JAOUEN & Fermic Edt.',X+2,Y+4-1,CTout)
 Else WrtScr('Copyright (c) 1991,93 T.JAOUEN',X+6,Y+4-1,CTout);

 For j := 1 To NamMax Do
  Begin
   WrtScr(' NAM'+_Val2Str(j,2)+':',X+1,Y+Ht-6-2-NamMax+j-3,CRien);

   If TNam[j]<>NIL Then
    With TNam[j]^.Cfg Do
     Begin
      If UART<>0 Then
        WrtScr(' U:'+Word2Hex( UART )+'h I:'+Byte2Hex(Irq)+
               ' S:'+_Val2Str(Spd,6)+'bds',X+6+1+1,Y+Ht-6-2-NamMax+j-3,CRien);
     End;
  End;

 For j := 1 To PavMax Do
  Begin
   WrtScr(' PAV '+Val2Str(j,1)+':',X+1,Y+Ht-6-2-NamMax+j-2+8+2,CRien);

   If TPav[j]<>NIL Then
    With TPav[j]^ Do
     Begin
      If Cfg.UART<>0 Then
        WrtScr(' U:'+Word2Hex( Cfg.UART )+'h I:'+Byte2Hex(Cfg.Irq)+
               ' S:'+_Val2Str(Cfg.Spd,6)+'bds CV:'+_Val2Str(PCfg.MinMax,2),X+6+1+1,Y+Ht-6-2-NamMax+j-2+8+2,CRien);
     End;
  End;

 WrtScr('( '+_Val2Str(memavail div 1024,3)+' Ko de mmoires libres )',X+8,Y+Ht-6+2,CRien);

 WrtScr(' Tapez une touche pour continuer ',X+6,Y+Ht-4+1,CRvs);
 WrtScr(' Alt-X pour Quitter ',X+13,Y+Ht-2,CRvs);

 Key := ' ';
 Funct := FALSE;

 tk := GetC18+18*15;
 While (tk>GetC18) Do
  Begin
   If KeyPressed Then
    Begin
     Key := ReadKey;
     If Key=#0 Then
      Begin
       Key := ReadKey;
       Funct := TRUE;
      End
     Else Funct := FALSE;
     Break;
    End;
  End;

 FillZc(0,0,80,ScrHi,32,CRien);

 PresenteSoft := Not((Funct And ((Key=#45) Or (Key=#16))) Or
                     (Not(Funct) And (Key=#27)));
End;


Procedure WriteCopyright( Help, BAL : Boolean );
Begin
 Write('Ŀ');
 If Fermic Then
  Begin
   Write('                              ---  NAMSIM 1.32  ---                           ');
   Write('               Copyright (C) 1993  T.JAOUEN & Fermic Editions                 ');
  End
 Else
  Begin
   Write('Le logiciel "NAMSIM" version 1.32 est dans le Domaine Public.                 ');
   Write('Ce logiciel et sa documentation ne peuvent pas faire l''objet d''une transaction');
   Write(' commerciale. Ils peuvent tre copis et utiliss sans restriction, cependant ');
   Write('ils ne doivent pas tre modifis. L''auteur ne peut pas tre tenu responsable  ');
   Write('de dommages directs ou indirects dcoulant de l''utilisation de ce logiciel.   ');
   Write('       Tous droits rservs.          Copyright (c) 1991-93  T.JAOUEN         ');
   Write('Ĵ');
   Write('    CE LOGICIEL PEUT ETRE DISTRIBUE ET UTILISE QU''AVEC LE LOGICIEL MULTIM     ');
  End;
 If Help Or BAL Then
  Begin
   Write('Ĵ');
   If BAL Then
    Begin
     Write('Vous pouvez contacter l''auteur par minitel:                                   ');
     Write('  tel.: 3614    code du service: TEASER     boite aux lettres: LOGICOS        ');
    End
   Else
    Begin
     Write('        Tapez NAMSIM /? pour la liste des options de configuration.           ');
    End;
  End;
 Write('');
End;




Function GoodParam : Boolean;
Var i : Byte;
    ok : Boolean;
Begin
 GoodParam := FALSE;
 ok := FALSE;
 For i := 1 To NamMax Do
  If TNam[i]<>NIL Then
   Begin
    ok := TRUE;
    Break;
   End;

 If Not(ok) Then Writeln('Dfinir au moins une gestion NAM...')
 Else GoodParam := TRUE;
End;

Function ComInit : Boolean;
Var j : Byte;
    HiSpeed : LongInt;
    Err : Boolean;
Begin
 HiSpeed := 0;
 For j := 1 To NamMax Do
  If TNam[j]<>NIL Then
   Begin
    With TNam[j]^ Do
     Begin
      If (Cfg.IRQ=0) And (HiSpeed<Cfg.Spd) Then HiSpeed := Cfg.Spd;
     End;
   End;

 For j := 1 To MinMax Do
  If TMin[j]<>NIL Then
   Begin
    With TMin[j]^ Do
     Begin
      If (Cfg.IRQ=0) And (HiSpeed<Cfg.Spd) Then HiSpeed := Cfg.Spd;
     End;
   End;

 For j := 1 To PavMax Do
  If TPav[j]<>NIL Then
   Begin
    With TPav[j]^ Do
     Begin
      If (Cfg.IRQ=0) And (HiSpeed<Cfg.Spd) Then HiSpeed := Cfg.Spd;
     End;
   End;

 If CheckInit(HiSpeed) Then
  Begin
   Err := FALSE;

   For j := 1 To NamMax Do
    If TNam[j]<>NIL Then
     Begin
      With TNam[j]^ Do
       Begin
        If Not(Com.Init(Cfg.UART,Cfg.IRQ,Cfg.Spd,Cfg.Par,Cfg.BufIn,Cfg.BufOut)) Then
         Begin
          Err := TRUE;
          Break;
         End;
       End;
     End;

   If Not(Err) Then
    Begin
     For j := 1 To MinMax Do
      If TMin[j]<>NIL Then
       Begin
        With TMin[j]^ Do
         Begin
          If Not(Com.Init(Cfg.UART,Cfg.IRQ,Cfg.Spd,Cfg.Par,Cfg.BufIn,Cfg.BufOut)) Then
           Begin
            Err := TRUE;
            Break;
           End;
         End;
       End;

     If Not(Err) Then
      Begin

       For j := 1 To PavMax Do
        If TPav[j]<>NIL Then
         Begin
          With TPav[j]^ Do
           Begin
            If Not(Com.Init(Cfg.UART,Cfg.IRQ,Cfg.Spd,Cfg.Par,Cfg.BufIn,Cfg.BufOut)) Then
             Begin
              Err := TRUE;
              Break;
             End;
           End;
         End;

       If Not(Err) Then
        Begin
         ComInit := TRUE;
         Exit;
        End;

       While(j>1) Do
        Begin
         Dec(j);
         If TPav[j]<>NIL Then TPav[j]^.Com.Done;
        End;

       j := MinMax;
      End;

     While(j>1) Do
      Begin
       Dec(j);
       If TMin[j]<>NIL Then TMin[j]^.Com.Done;
      End;

     j := NamMax;
    End;

   While(j>1) Do
    Begin
     Dec(j);
     If TNam[j]<>NIL Then TNam[j]^.Com.Done;
    End;

   CheckDone;
   ComInit := FALSE;
  End
 Else ComInit := FALSE;
End;

Procedure ComDone;
Var j : Byte;
Begin
 For j := 1 To NamMax Do
  Begin
   If (TNam[j]<>NIL) Then TNam[j]^.Com.Done;
  End;

 For j := 1 To MinMax Do
  Begin
   If (TMin[j]<>NIL) Then TMin[j]^.Com.Done;
  End;

 For j := 1 To PavMax Do
  Begin
   If (TPav[j]<>NIL) Then TPav[j]^.Com.Done;
  End;
End;

Procedure VoiesInit;
Var i : Byte;
    j : Byte;
Begin
 For j := 1 To NamMax Do TNam[j] := NIL;

 For j := 1 To MinMax Do TMin[j] := NIL;

 For j := 1 To PavMax Do TPav[j] := NIL;

 For i := 0 To NbCStr-1 Do TabCStr[i] := '';

 FCStr := 0;
 nCStr := 0;

 NbNab := 0;

 CNam := NIL;
 nCNam := 0;
 CCfg := NIL;
 CMin := NIL;
 nCMin := 0;
 CPav := NIL;
 nCPav := 0;
End;


Begin

 VoiesInit;

 If ChargeParam Then
  If NeedHelp Then
   Begin
    Writeln('NamSim  v1.32, Copyright (c) 1991,94 T.JAOUEN');
    Writeln;
    Writeln('---Options---');
    Writeln(' /MDA   carte video monochrome (Herc.)| /CGA   carte video couleur');
    Writeln(' /EGA   Force un affichage EGA (/EGA2)| /VGA   force un affichage VGA');
    Writeln(' /GRIS VGA gris ou couleurs          | /SNOW CGA avec neige');
    Writeln(' /NAM   nouveau rseau NAM...         | /MIN   nouveau minitel...');
    Writeln(' /COM=  AdresseUART,nIRQ             | /SPD=  vitesse de communication');
    Writeln(' /COM1 /COM2 /COM3 /COM4 standard DOS | /PAR=  paramtre de com. N81 ...');
    Writeln(' /BUF=  entres, sorties (tailles)    | /CNX  connexion automatique (NAM)');
    Writeln(' /CALL= nvoie,paramtre (NAM)        | /CSTR= mmoire de donnes (NAM)');
    Writeln(' /CL   champs CL0/CL1 prsent? (NAM) | /FREE saisie d''appel libre (NAM)');
    Writeln(' /RTC  minitel pour RTC (MIN)        | /NAB=  NAB,donne');
    Writeln(' /DRCS emule DRCS (1 Ko...) (NAM)    | /RESO liaison en "rseau"');
    Writeln(' /#NAM= forcer un num.NAM pour minitel| /ETB  fin de trame particuliere...');
    Writeln(' /HISPD autorise les vitesses >38400  | /SUBST=conversion de nom de pages');
    Writeln;
    WriteCopyright(FALSE,TRUE);
   End
  Else
   Begin
    { pour le dernier NAM ... }
    ClasseNam;
    { et pour le dernier MIN ... }
    ClasseMin;
    { et pour le dernier PAV ... }
    ClassePav;

    If GoodParam Then
     Begin

      HeapFail := FALSE;
      HeapError := @FoncTas;
      CheckBreak := FALSE;

      VideoInit;

      If VideoEga Then
       Begin
        ScrHi := 35;
        NbVoies := MaxNbVoies;
       End
      Else NbVoies := 16;

      If ComInit Then
       Begin
        NamInit;
        MinInit;
        PavInit;

        If PresenteSoft Then
         Begin
          MainInit;
          While Not(EndMain) Do Main(TRUE);
          MainDone;
         End;

        PavDone;
        MinDone;

        ComDone;
       End;
      VideoDone;

      HeapError := NIL;

      WriteCopyright(FALSE,FALSE)
     End
    Else WriteCopyright(TRUE,FALSE);
   End;
End.
